"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.activityPubPlugin = void 0;
var fs = __importStar(require("node:fs"));
var node_path_1 = __importDefault(require("node:path"));
var node_fetch_1 = __importDefault(require("node-fetch"));
var saveWebfinger = function (outputDir, wf) {
    if (!fs.existsSync("".concat(outputDir, "/.well-known"))) {
        fs.mkdirSync("".concat(outputDir, "/.well-known"));
    }
    fs.writeFileSync("".concat(outputDir, "/.well-known/webfinger"), JSON.stringify(wf));
};
/** @param {import("@11ty/eleventy").UserConfig} eleventyConfig */
var activityPubPlugin = function (eleventyConfig, _a) {
    var domain = _a.domain, username = _a.username, _b = _a.displayName, displayName = _b === void 0 ? username : _b, summary = _a.summary, outbox = _a.outbox, alias = _a.alias, outboxCollection = _a.outboxCollection, avatar = _a.avatar;
    if (!alias) {
        eleventyConfig.on("eleventy.after", function (_a) {
            var dir = _a.dir;
            var url = "https://".concat(domain);
            var actorDef = {
                "@context": [
                    "https://www.w3.org/ns/activitystreams",
                    "https://w3id.org/security/v1",
                ],
                id: "https://".concat(domain, "/").concat(username),
                type: "Person",
                preferredUsername: username,
                name: displayName,
                url: domain,
                inbox: "".concat(url, "/inbox"),
                attachments: [
                    {
                        type: "PropertyValue",
                        name: "Website",
                        value: "https://".concat(domain)
                    },
                ],
                summary: summary
            };
            if (avatar) {
                actorDef.icon = {
                    type: "Image",
                    mediaType: "image/jpeg",
                    url: avatar
                };
            }
            if (outbox) {
                actorDef.outbox = "".concat(url, "/outbox_1");
            }
            fs.writeFileSync("".concat(dir.output, "/").concat(username), JSON.stringify(actorDef));
            fs.writeFileSync("".concat(dir.output, "/").concat(username, ".json"), JSON.stringify(actorDef));
        });
    }
    eleventyConfig.on("eleventy.after", function (_a) {
        var dir = _a.dir;
        return __awaiter(void 0, void 0, void 0, function () {
            var url, response, sourceWf, wf, wf;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!alias) return [3 /*break*/, 5];
                        url = "https://".concat(alias.domain, "/.well-known/webfinger?resource=acct:").concat(alias.username, "@").concat(alias.domain);
                        return [4 /*yield*/, (0, node_fetch_1["default"])(url)];
                    case 1:
                        response = _b.sent();
                        if (!response.ok) return [3 /*break*/, 3];
                        return [4 /*yield*/, response.json()];
                    case 2:
                        sourceWf = (_b.sent());
                        if (sourceWf) {
                            wf = __assign(__assign({}, sourceWf), { subject: "acct:".concat(username, "@").concat(domain), aliases: __spreadArray(__spreadArray([], (sourceWf.aliases || []), true), [
                                    "https://".concat(domain, "/").concat(username),
                                ], false) });
                            saveWebfinger(dir.output, wf);
                        }
                        return [3 /*break*/, 4];
                    case 3: throw new Error("Failed to retrieve Webfinger file for ".concat(username, "@").concat(domain));
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        wf = {
                            subject: "acct:".concat(username, "@").concat(domain),
                            links: [
                                {
                                    rel: "self",
                                    type: "application/activity+json",
                                    href: "https://".concat(domain, "/").concat(username)
                                },
                                {
                                    rel: "http://webfinger.net/rel/profile-page",
                                    type: "text/html",
                                    href: "https://".concat(domain)
                                },
                            ]
                        };
                        saveWebfinger(dir.output, wf);
                        _b.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    });
    eleventyConfig.addFilter("activitypubjson", function (obj) {
        return JSON.stringify(obj, null, 2);
    });
    eleventyConfig.addFilter("activitypubwrapoutbox", function (obj) { return ({
        "@context": ["https://www.w3.org/ns/activitystreams"],
        type: "OrderedCollectionPage",
        id: "https://".concat(domain, "/outbox"),
        orderedItems: obj
    }); });
    eleventyConfig.addFilter("activitypuboutboxroot", function (items) { return ({
        "@context": "https://www.w3.org/ns/activitystreams",
        id: "https://".concat(domain, "/").concat(username, "/outbox"),
        type: "OrderedCollection",
        totalItems: items.length,
        first: "https://".concat(domain, "/outbox_page"),
        last: "https://".concat(domain, "/outbox_page")
    }); });
    eleventyConfig.addFilter("activitypuboutbox", function (items) { return ({
        "@context": "https://www.w3.org/ns/activitystreams",
        type: "OrderedCollectionPage",
        id: "https://".concat(domain, "/outbox_1"),
        orderedItems: items.sort().map(function (item) { return ({
            actor: "https://".concat(domain, "/").concat(username),
            type: "Create",
            published: item.date.toISOString(),
            id: "https://".concat(domain).concat(item.url, "publish"),
            to: ["https://www.w3.org/ns/activitystreams#Public"],
            object: {
                attributedTo: "https://".concat(domain, "/").concat(username),
                content: "<p>".concat(item.data.title, "</p><p><a href=\"https://").concat(domain).concat(item.url, "\">https://").concat(domain).concat(item.url, "</a></p>"),
                id: "https://".concat(domain, "/").concat(item.url),
                inReplyTo: null,
                published: item.date.toISOString(),
                to: ["https://www.w3.org/ns/activitystreams#Public"],
                type: "Note",
                url: "https://".concat(domain).concat(item.url)
            }
        }); })
    }); });
    if (outbox) {
        eleventyConfig.addGlobalData("activitypuboutboxcollection", outboxCollection);
        eleventyConfig.on("eleventy.before", function (_a) {
            var dir = _a.dir;
            fs.mkdirSync("".concat(dir.input, "/outbox"));
            fs.copyFileSync("".concat(__dirname, "/../src/templates/outbox.njk"), node_path_1["default"].resolve("./".concat(dir.input, "/outbox/outbox.njk")));
            fs.copyFileSync("".concat(__dirname, "/../src/templates/outbox_page.njk"), "./".concat(dir.input, "/outbox/outbox_page.njk"));
        });
        eleventyConfig.on("eleventy.after", function (_a) {
            var dir = _a.dir;
            fs.rmSync("".concat(dir.input, "/outbox"), { recursive: true, force: true });
        });
    }
};
exports.activityPubPlugin = activityPubPlugin;
