export declare class Bytes {
    private readonly _bytes;
    length: number;
    constructor(bytes: Uint8Array);
    array(): Uint8Array;
    utf8(): string;
    base64(): string;
    arrayBuffer(): ArrayBuffer;
    sha256(): Promise<Bytes>;
    static fromBase64(str: string): Bytes;
    static fromUtf8(str: string): Bytes;
    static fromArrayBuffer(buffer: ArrayBuffer): Bytes;
    static from(obj: string | ArrayBuffer, encoding?: "utf-8" | "base64"): Bytes;
}
export declare const generateKeyPair: () => Promise<CryptoKeyPair>;
export declare const exportKeyToPem: (key: CryptoKey, type: 'private' | 'public') => Promise<string>;
export declare const sign: (key: CryptoKey, data: Bytes) => Promise<Bytes>;
export declare const importKeyFromPem: (pemText: string, type: 'private' | 'public') => Promise<CryptoKey>;
export declare const signMessage: (key: CryptoKey, message: string) => Promise<string>;
